import { NodeProp } from "lezer-tree";
import { Style } from "style-mod";
import { Extension } from "@codemirror/next/state";
export declare class TagSystem {
    flags: readonly string[];
    types: readonly string[];
    flagMask: number;
    typeShift: number;
    typeNames: string[];
    typeIDs: {
        [name: string]: number;
    };
    parents: number[];
    prop: NodeProp<number>;
    constructor(options: {
        flags: string[];
        types: string[];
        subtypes?: number;
    });
    get(name: string): number;
    add(tags: {
        [selector: string]: string;
    }): import("lezer-tree").NodePropSource;
    highlighter(spec: {
        [tag: string]: Style;
    }): Extension;
    specificity(tag: number): number;
}
export declare const defaultTags: TagSystem;
export declare const styleTags: (tags: {
    [selector: string]: string;
}) => import("lezer-tree").NodePropSource;
export declare const highlighter: (spec: {
    [tag: string]: Style;
}) => Extension;
export declare const defaultHighlighter: Extension;
//# sourceMappingURL=highlight.d.ts.map