import { EditorView, Command } from "@codemirror/next/view";
import { Extension } from "@codemirror/next/state";
export interface Diagnostic {
    from: number;
    to: number;
    severity: "info" | "warning" | "error";
    source?: string;
    message: string;
    actions?: readonly Action[];
}
export interface Action {
    name: string;
    apply: (view: EditorView, from: number, to: number) => void;
}
export declare const setDiagnostics: import("../../state/src").StateEffectType<readonly Diagnostic[]>;
export declare function linting(): Extension;
export declare const openLintPanel: Command;
export declare const closeLintPanel: Command;
export declare function linter(source: (view: EditorView) => readonly Diagnostic[] | Promise<readonly Diagnostic[]>): Extension;
//# sourceMappingURL=lint.d.ts.map