import { Tree, NodeType, NodeProp } from "lezer-tree";
import { Line } from "@codemirror/next/text";
import { EditorState } from "./state";
import { Transaction } from "./transaction";
import { Facet } from "./facet";
import { Change, ChangeSet } from "./change";
import { EditorSelection } from "./selection";
export declare type StateCommand = (target: {
    state: EditorState;
    dispatch: (transaction: Transaction) => void;
}) => boolean;
export declare const allowMultipleSelections: Facet<boolean, boolean>;
export declare const changeFilter: Facet<(change: Change, state: EditorState, before: ChangeSet<Change>) => readonly Change[] | null, readonly ((change: Change, state: EditorState, before: ChangeSet<Change>) => readonly Change[] | null)[]>;
export declare const selectionFilter: Facet<(selection: EditorSelection, state: EditorState, changes: ChangeSet<Change>) => EditorSelection, readonly ((selection: EditorSelection, state: EditorState, changes: ChangeSet<Change>) => EditorSelection)[]>;
export declare const languageData: NodeProp<{
    [key: string]: any;
}>;
export declare const addLanguageData: Facet<{
    type: NodeType;
} & {
    [key: string]: any;
}, readonly ({
    type: NodeType;
} & {
    [key: string]: any;
})[]>;
export interface Syntax {
    getTree(state: EditorState): Tree;
    parsePos(state: EditorState): number;
    ensureTree(state: EditorState, upto: number, timeout?: number): Tree | null;
    docNodeType: NodeType;
    docNodeTypeAt(state: EditorState, pos: number): NodeType;
}
export declare class IndentContext {
    readonly state: EditorState;
    readonly overrideIndentation?: ((pos: number) => number) | undefined;
    constructor(state: EditorState, overrideIndentation?: ((pos: number) => number) | undefined);
    get unit(): number;
    textAfterPos(pos: number): string;
    countColumn(line: string, pos: number): number;
    lineIndent(line: Line): number;
    column(pos: number): number;
}
//# sourceMappingURL=extension.d.ts.map